#!/usr/bin/perl
########################################################################
#
# $Id: check_updates.pl,v 1.9 2015/03/13 13:52:44 gosha Exp $
#
#		(c) Okunev Igor <igor[at]prv.mts-nn.ru> 2012 - 2015
#
########################################################################
use strict;

open STDERR, '>>/var/log/VirtualPBX/XVB.stderr';

use LWP::UserAgent;
use HTTP::Request;

my $ua = LWP::UserAgent->new();
my %ver;
my $latest_ver;
my $cmd = 'rpm -qv virtual-pbx | sort | tail -1';
my $cur_ver = `$cmd`;
	
$cur_ver =~ s/virtual-pbx-.*_(\d+)(_dev)?(\.noarch)?$/$1/;
chomp( $cur_ver );

sleep(int(rand(100)));

my $user = 'free';

if ( -e '/opt/VirtualPBX/etc/key.lic' ) {
	if ( open(LIC,'</opt/VirtualPBX/etc/key.lic') ) {
		while(<LIC>) {
			if ( /Customer:\s*(.*)/) {
				$user = escape($1);
				last;
			}
		}
		close(LIC);
	}
}

my $req = HTTP::Request->new( GET => 'http://virtual-pbx.ru/cgi/checkupdates.cgi?ver='. $cur_ver .'&id='. $user );
my $res = $ua->request($req);

unless ( $res->is_success ) {
	$req = HTTP::Request->new( GET => 'http://virtual-pbx.ru/updates/vpbx/' );
	$res = $ua->request($req);
}

%ver = ();

if ( $res->is_success ) {
	my $content = $res->content();

	foreach my $update ( $content =~ /(VirtualPBX-\d+.tgz)/g ) {
		if ( $update =~ /VirtualPBX-(\d+).tgz/ ) {
			$ver{$update} = $1;
		}
	}
	
	$latest_ver = $ver{(( sort { $ver{$b} <=> $ver{$a} } keys %ver ))[0]};
	
}

if ( $latest_ver > $cur_ver ) {
	$req = HTTP::Request->new( GET => 'http://virtual-pbx.ru/changelog.html' );
	$res = $ua->request($req);
	my $label_str = '';
	if ( $res->is_success ) {
		my $content = $res->content();
		my @content_str = split(/\n/,$content);
		foreach my $feature_str ( @content_str ) {
			if ( $feature_str =~ /<font color="green">(.*build\s+(\d+).*)/ ) {
				if ( $2 > $cur_ver ) {
					$label_str .= "$1\n";
				}
			}
		}
	}
	$label_str =~ s#'#"#gs;
	$label_str =~ s#</font>##gs;
	print "<br /><br /><a class='error' href='http://virtual-pbx.ru/updates/vpbx/VirtualPBX-$latest_ver.tgz' title='$label_str'>!!! Update to $latest_ver available !!!</a>";
} else {
	print "";
}

sub escape {
	my $str = shift;

	$str =~ s#([^\w\d-])# '%'. unpack('H2', $1) #ge;

	return $str;
}

